#include <iostream>
#include <utility>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>
#define fi first
#define se second
using namespace std;

const int MAXN = 300005;
const int INF = 1 << 30;

int n, m;
vector<pair<int, int>> v, line1, line2;
int stat[MAXN];

set<int> opt;
queue<pair<int, int>> pre;

int getMax()
{
    if (opt.size() == 0) return 0;
    else return *(--opt.end());
}

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        int l, r;
        cin >> l >> r;
        line1.emplace_back(l, +i);
        line1.emplace_back(r, -i);
        line2.emplace_back(l, -i);
        line2.emplace_back(r + 1, +i);
        v.emplace_back(l, r);
    }

    sort(line1.begin(), line1.end());
    sort(line2.begin(), line2.end());
}

int main()
{
    Init();

    int ans = 0;
    int le = -m, ri = 0;
    int nxtl = 0, nxtr = 0;
    int current = 0;
    while (nxtl != line1.size() and nxtr != line2.size())
    {
        int dstl = INF, dstr = INF;
        if (nxtl != line1.size()) dstl = line1[nxtl].fi - le;
        if (nxtr != line2.size()) dstr = line2[nxtr].fi - ri;

        if (dstl <= dstr)
        {
            le = line1[nxtl].fi;
            ri = le + m;
            int idx = line1[nxtl].se;
            bool io = 0;
            if (idx < 0)
            {
                idx = -idx;
                io = 1;
            }

            if (io == 0)
            {
                if (stat[idx] == 1) {stat[idx] = 2; current++;}
                if (stat[idx] == 3) stat[idx] = 4;

            }
            if (io == 1)
            {
                if (stat[idx] == 4) stat[idx] = 0;
            }

            nxtl++;
        }
        else
        {
            ri = line2[nxtr].fi;
            le = ri - m;
            int idx = line2[nxtr].se;
            bool io = 1;
            if (idx < 0)
            {
                idx = - idx;
                io = 0;
            }

            if (io == 0)
            {
                if (stat[idx] == 0) stat[idx] = 1;
            }
            if (io == 1)
            {
                if (stat[idx] == 1) stat[idx] = 3;
                if (stat[idx] == 2) {stat[idx] = 4; current--;}
            }

            nxtr++;
        }

        /*cout << "for the interval " << "[" << le << ", " << ri << "]" << " the answer is " << current << endl;
        cout << "status: " ;
        for (int j = 1; j <= n; ++ j) cout << stat[j] << ' ';
        cout << endl;*/

        pre.emplace(ri, current);
        while (pre.front().fi <= le)
        {
            opt.insert(pre.front().se);
            pre.pop();
        }

        ans = max(ans, current + getMax());
    }

    cout << ans << endl;
    return 0;
}

/*
4 1
1 12
4 11
6 15
2 8
*/
