#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 1503;

int n, m, q;
char a[MAXN][MAXN];

vector<int> g[MAXN * MAXN];
bool vis[MAXN][MAXN];
int mint[MAXN * MAXN], maxt[MAXN * MAXN];
int dep[MAXN * MAXN];
int timer = 0;

bool no_init_cycle = true;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cin >> a[i][j];
            if (j != m and a[i][j] == '>') g[i * m + j].emplace_back(i * m + j + 1);
            if (j != 1 and a[i][j] == '<') g[i * m + j].emplace_back(i * m + j - 1);
            if (i != 1 and a[i][j] == '^') g[i * m + j].emplace_back((i - 1) * m + j);
            if (j != n and a[i][j] == 'v') g[i * m + j].emplace_back((i + 1) * m + j);
        }
    }
}

void DFS(int u)
{
    if (mint[u] == 0) mint[u] = ++timer;
    else
    {
        if (maxt[u] == 0) no_init_cycle = false;
        return;
    }

    dep[u] = 1;
    int tmp = 0;
    for (int v : g[u])
    {
        DFS(v);
        dep[u] = dep[v] + 1;
        tmp = max(tmp, maxt[v]);
    }

    maxt[u] = max(tmp, mint[u]);
}

int Answer(int x, int y)
{
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            vis[i][j] = 0;
        }
    }

    int cnt = 0;
    while (x >= 1 and x <= n and y >= 1 and y <= m)
    {
        vis[x][y] = 1;

        if (a[x][y] == '^') x--;
        else if (a[x][y] == '<') y--;
        else if (a[x][y] == '>') y++;
        else x++;
        if (vis[x][y] == 1) return 0;
        else cnt++;
    }

    return cnt++;
}

void Solve()
{
    cin >> q;
    for (int i = 1; i <= q; ++ i)
    {
        int sx, sy, cx, cy;
        char cd, orig;
        cin >> sx >> sy >> cx >> cy >> cd;

        int from, to, newt, start = sx * m + sy;
        from = cx * m + cy;
        if (a[cx][cy] == '>') to = (cy == m) ? 0 : cx * m + cy + 1;
        if (a[cx][cy] == '<') to = (cy == 1) ? 0 : cx * m + cy - 1;
        if (a[cx][cy] == 'v') to = (cx == n) ? 0 : (cx + 1) * m + cy;
        if (a[cx][cy] == '^') to = (cx == 1) ? 0 : (cx - 1) * m + cy;

        if (cd == '>') to = (cy == m) ? 0 : cx * m + cy + 1;
        if (cd == '<') to = (cy == 1) ? 0 : cx * m + cy - 1;
        if (cd == 'v') to = (cx == n) ? 0 : (cx + 1) * m + cy;
        if (cd == '^') to = (cx == 1) ? 0 : (cx - 1) * m + cy;

        if (mint[from] < mint[start] or mint[from] > maxt[start]) cout << dep[start] << endl;
        else
        {
            if (mint[newt] <= mint[from] and mint[from] <= maxt[newt]) cout << 0 << endl;
            else
            {
                cout << dep[start] - dep[to] + dep[newt] << endl;
            }
        }
    }

}

int main()
{
    Init();

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            DFS(i * m + j);
        }
    }

    if (no_init_cycle)
    {
        Solve();
        return 0;
    }

    cin >> q;
    for (int i = 1; i <= q; ++ i)
    {
        int sx, sy, cx, cy;
        char cd, orig;
        cin >> sx >> sy >> cx >> cy >> cd;
        orig = a[cx][cy];
        a[cx][cy] = cd;
        cout << Answer(sx, sy) << endl;
        a[cx][cy] = orig;
    }

    return 0;
}
