#include<bits/stdc++.h>
using namespace std;

const int nmax=1.5e3+42,qmax=1e5+42;

int n,m;

char inp[nmax][nmax];

void read_char(char &c)
{
    c=getchar();

    while(c!='<'&&c!='>'&&c!='^'&&c!='v')c=getchar();
}

int been[nmax][nmax];

int q_now;

struct query
{
    int x_start,y_start,x_change,y_change;
    char cur;
};
query queries[qmax];

vector< int > adj[nmax*nmax];
int in[nmax*nmax],out[nmax*nmax],t=0;

void dfs(int node)
{
    t++;

    in[node]=t;

    for(auto k:adj[node])
        dfs(k);

    out[node]=t;
}

int mem[nmax][nmax];

int hsh(int x,int y)
{
    if(x<=0||x>=n+1||y<=0||y>=m+1)return 0;
    return y+(x-1)*m;
}
void go_back(int x,int y,int x_parent,int y_parent,int moves)
{
    if(moves)
    {
        if(x<=0||x>=n+1||y<=0||y>=m+1)return;

        adj[hsh(x_parent,y_parent)].push_back(hsh(x,y));
    }

    mem[x][y]=moves;

    if(inp[x-1][y]=='v')go_back(x-1,y,x,y,moves+1);

    if(inp[x+1][y]=='^')go_back(x+1,y,x,y,moves+1);

    if(inp[x][y-1]=='>')go_back(x,y-1,x,y,moves+1);

    if(inp[x][y+1]=='<')go_back(x,y+1,x,y,moves+1);
}

int slow(query now)
{
    q_now++;

    int x=now.x_start,y=now.y_start;
    int x_change=now.x_change;
    int y_change=now.y_change;
    char c=now.cur;

    //cout<<"going "<<x<<" "<<y<<" "<<x_change<<" "<<y_change<<" "<<c<<endl;

    char was=inp[x_change][y_change];

    inp[x_change][y_change]=c;
    q_now++;

    int outp=0;

    while(been[x][y]!=q_now)
    {
        been[x][y]=q_now;

        if(inp[x][y]=='<')y--;
        else if(inp[x][y]=='>')y++;
        else if(inp[x][y]=='^')x--;
        else x++;

        outp++;

        if(x==0||x==n+1||y==0||y==m+1)
        {
            inp[x_change][y_change]=was;

            return outp;
        }
    }

    inp[x_change][y_change]=was;

    return 0;
}

bool is_parent(int u,int v)
{
    return in[v]<=in[u]&&out[u]<=out[v];
}

int faster(query now)
{
    if(is_parent(hsh(now.x_start,now.y_start),hsh(now.x_change,now.y_change))==0)return mem[now.x_start][now.y_start];

                int outp=mem[now.x_start][now.y_start]-mem[now.x_change][now.y_change];
                int add=0;

                int x_new=now.x_change;
                int y_new=now.y_change;

                if(now.cur=='v')x_new++;
                else if(now.cur=='^')x_new--;
                else if(now.cur=='>')y_new++;
                else y_new--;

                if(x_new==0||x_new==n+1||y_new==0||y_new==m+1)add=1;
                else
                {
                    if(mem[x_new][y_new]==0)add=0;

                    if(is_parent(hsh(x_new,y_new),hsh(now.x_change,now.y_change)))add=0;
                    else add=1+mem[x_new][y_new];
                }
                //cout<<"outp= "<<outp<<" add= "<<add<<endl;

                if(add==0)outp=0;
                else outp+=add;

                return outp;
}
int main()
{
    scanf("%i%i",&n,&m);

    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            read_char(inp[i][j]);

    for(int i=0;i<=n+1;i++)
        for(int j=0;j<=m+1;j++)
        {
            if(1<=i&&i<=n&&j!=0)j=m+1;

            if(i==0||i==n+1||j==0||j==m+1)
                go_back(i,j,i,j,0);
        }

    dfs(0);

    int q;
    scanf("%i",&q);

    for(int i=1;i<=q;i++)
    {
        scanf("%i%i%i%i",&queries[i].x_start,&queries[i].y_start,&queries[i].x_change,&queries[i].y_change);

        read_char(queries[i].cur);

        if(mem[queries[i].x_start][queries[i].y_start]!=0)
        {
            //cout<<"faster!"<<endl;

            printf("%i\n",faster(queries[i]));
            //printf("%i\n",slow(queries[i]));
        }
        else
        {
            printf("%i\n",slow(queries[i]));
        }
    }

    return 0;
}
