#include<bits/stdc++.h>
using namespace std;

const int nmax=1.5e3+42,qmax=1e5+42;

int n,m;

char inp[nmax][nmax];

void read_char(char &c)
{
    c=getchar();

    while(c!='<'&&c!='>'&&c!='^'&&c!='v')c=getchar();
}

int been[nmax][nmax];

int q_now;

struct query
{
    int x_start,y_start,x_change,y_change;
    char cur;
};
query queries[qmax];

vector< int > adj[nmax*nmax];
int in[nmax*nmax],out[nmax*nmax],t=0;

void dfs(int node)
{
    t++;

    in[node]=t;

    for(auto k:adj[node])
        dfs(k);

    out[node]=t;
}

int mem[nmax][nmax];

int hsh(int x,int y)
{
    if(x<=0||x>=n+1||y<=0||y>=m+1)return 0;
    return y+(x-1)*m;
}
void go_back(int x,int y,int x_parent,int y_parent,int moves)
{
    if(moves)
    {
        if(x<=0||x>=n+1||y<=0||y>=m+1)return;

        adj[hsh(x_parent,y_parent)].push_back(hsh(x,y));
    }

    mem[x][y]=moves;

    if(inp[x-1][y]=='v')go_back(x-1,y,x,y,moves+1);

    if(inp[x+1][y]=='^')go_back(x+1,y,x,y,moves+1);

    if(inp[x][y-1]=='>')go_back(x,y-1,x,y,moves+1);

    if(inp[x][y+1]=='<')go_back(x,y+1,x,y,moves+1);
}

int slow(query now)
{
    q_now++;

    int x=now.x_start,y=now.y_start;
    int x_change=now.x_change;
    int y_change=now.y_change;
    char c=now.cur;

    //cout<<"going "<<x<<" "<<y<<" "<<x_change<<" "<<y_change<<" "<<c<<endl;

    char was=inp[x_change][y_change];

    inp[x_change][y_change]=c;
    q_now++;

    int outp=0;

    while(been[x][y]!=q_now)
    {
        been[x][y]=q_now;

        if(inp[x][y]=='<')y--;
        else if(inp[x][y]=='>')y++;
        else if(inp[x][y]=='^')x--;
        else x++;

        outp++;

        if(x==0||x==n+1||y==0||y==m+1)
        {
            inp[x_change][y_change]=was;

            return outp;
        }
    }

    inp[x_change][y_change]=was;

    return 0;
}

bool is_parent(int u,int v)
{
    return in[v]<=in[u]&&out[u]<=out[v];
}

int faster(query now)
{
    if(is_parent(hsh(now.x_start,now.y_start),hsh(now.x_change,now.y_change))==0)return mem[now.x_start][now.y_start];

                int outp=mem[now.x_start][now.y_start]-mem[now.x_change][now.y_change];
                int add=0;

                int x_new=now.x_change;
                int y_new=now.y_change;

                if(now.cur=='v')x_new++;
                else if(now.cur=='^')x_new--;
                else if(now.cur=='>')y_new++;
                else y_new--;

                //cout<<x_new<<" "<<y_new<<" "<<mem[x_new][y_new]<<endl;

                if(x_new==0||x_new==n+1||y_new==0||y_new==m+1)add=1;
                else
                {
                    if(mem[x_new][y_new]==0)add=0;
                    else if(is_parent(hsh(x_new,y_new),hsh(now.x_change,now.y_change)))add=0;
                    else add=1+mem[x_new][y_new];
                }
                //cout<<"outp= "<<outp<<" add= "<<add<<endl;

                if(add==0)outp=0;
                else outp+=add;

                return outp;
}





int parent[nmax*nmax];
int root(int node)
{
    if(parent[node]==node)return node;
    parent[node]=root(parent[node]);
    return parent[node];
}

vector< int > MEM_CYCLE;

vector<int> help;

void cut_edge(int u,int v)
{
    //cout<<"cut "<<u<<" "<<v<<endl;

    help={};

    for(auto w:adj[u])
        if(w!=v)help.push_back(w);

    adj[u]=help;
}

int CYCLE_ID[nmax*nmax],CYCLE_SZ[nmax*nmax];

vector<int> CYCLE;



void find_cycles()
{
    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            parent[hsh(i,j)]=hsh(i,j);

    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            if(mem[i][j]==0)
            {
                int u=hsh(i,j);

                int x=i,y=j;

                if(inp[x][y]=='^')x--;
                else if(inp[x][y]=='v')x++;
                else if(inp[x][y]=='<')y--;
                else y++;

                int v=hsh(x,y);

                parent[root(u)]=root(v);

                adj[v].push_back(u);
            }

    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            if(mem[i][j]==0&&parent[root(hsh(i,j))]==hsh(i,j))
            {
                //cout<<i<<" "<<j<<" "<<root(hsh(i,j))<<endl;

                int i_now=i,j_now=j;

                MEM_CYCLE={};

                while(been[i_now][j_now]==0)
                {
                    MEM_CYCLE.push_back(hsh(i_now,j_now));

                    been[i_now][j_now]=1;

                    if(inp[i_now][j_now]=='^')i_now--;
                    else if(inp[i_now][j_now]=='v')i_now++;
                    else if(inp[i_now][j_now]=='>')j_now++;
                    else j_now--;
                }

                //cout<<"MEM_CYCLE: ";for(auto w:MEM_CYCLE)cout<<w<<" ";cout<<endl;

                //i_now, j_now is the new root

                int pos=-1;

                for(int w=0;w<MEM_CYCLE.size();w++)
                    if(MEM_CYCLE[w]==hsh(i_now,j_now))pos=w;

                CYCLE={};

                for(int i=pos;i<MEM_CYCLE.size();i++)
                    CYCLE.push_back(MEM_CYCLE[i]);

                //cout<<"CYCLE: ";for(auto w:CYCLE)cout<<w<<" ";cout<<endl;

                cut_edge(MEM_CYCLE[1],hsh(i_now,j_now));

                dfs(hsh(i_now,j_now));

                CYCLE_SZ[hsh(i,j)]=CYCLE.size();

                for(int w=0;w<CYCLE.size();w++)
                    CYCLE_ID[CYCLE[w]]=w+1;
            }
}






int solve_cycle(query now)
{
    /*
    cout<<now.x_start<<" "<<now.y_start<<" "<<now.x_change<<" "<<now.y_change<<endl;
    cout<<cycle[now.x_start][now.y_start]<<" "<<cycle[now.x_change][now.y_change]<<endl;
    */
    if(root(hsh(now.x_start,now.y_start))!=root(hsh(now.x_change,now.y_change)))return 0;

    return slow(now);
    /*
                int outp=depth[now.x_start][now.y_start]-mem[now.x_change][now.y_change];
                int add=0;

                int x_new=now.x_change;
                int y_new=now.y_change;

                if(now.cur=='v')x_new++;
                else if(now.cur=='^')x_new--;
                else if(now.cur=='>')y_new++;
                else y_new--;

                //cout<<x_new<<" "<<y_new<<" "<<mem[x_new][y_new]<<endl;

                if(x_new==0||x_new==n+1||y_new==0||y_new==m+1)add=1;
                else
                {
                    if(mem[x_new][y_new]==0)add=0;
                    else if(is_parent(hsh(x_new,y_new),hsh(now.x_change,now.y_change)))add=0;
                    else add=1+mem[x_new][y_new];
                }
                //cout<<"outp= "<<outp<<" add= "<<add<<endl;

                if(add==0)outp=0;
                else outp+=add;

                return outp;
    */
}


int main()
{
    //freopen("trash.txt","r",stdin);

    scanf("%i%i",&n,&m);

    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            read_char(inp[i][j]);

    for(int i=0;i<=n+1;i++)
        for(int j=0;j<=m+1;j++)
        {
            if(1<=i&&i<=n&&j!=0)j=m+1;

            if(i==0||i==n+1||j==0||j==m+1)
                go_back(i,j,i,j,0);
        }

    dfs(0);

    find_cycles();

    memset(been,0,sizeof(been));

    int q;
    scanf("%i",&q);

    for(int i=1;i<=q;i++)
    {
        scanf("%i%i%i%i",&queries[i].x_start,&queries[i].y_start,&queries[i].x_change,&queries[i].y_change);

        read_char(queries[i].cur);

        if(mem[queries[i].x_start][queries[i].y_start]!=0)
        {
            printf("%i\n",faster(queries[i]));
        }
        else
        {
            int should=solve_cycle(queries[i]);

            //int is=slow(queries[i]);

            //cout<<"should "<<should<<" is "<<is<<endl;

            //assert(should==is);

            printf("%i\n",should);
        }
    }

    return 0;
}