#include <iostream>
#include <vector>
#include <algorithm>

#define ENDL '\n'

namespace {
template <class T>
using vec = std::vector<T>;

template <class T>
using mat = vec<vec<T>>;

using std::pair;

auto solve(vec<pair<int, int>>& visitors, int m) {
    auto max_leave = std::numeric_limits<int>::min();

    for (auto& [_, leave] : visitors) {
        max_leave = std::max(max_leave, leave);
    }

    vec<int> res(max_leave + 1);

    for (auto e = m; e <= max_leave + m; ++e) {
        auto b = e - m;
        auto curr_res = 0;
        for (auto& [curr_b, curr_e] : visitors) {
            if (curr_b > b || curr_e < e) {
                continue;
            }

            ++curr_res;
        }

        res[b] = curr_res;
    }

    auto sol = 0;
    for (auto b1 = 0; b1 < res.size(); ++b1) {
        auto e1 = b1 + m;
        for (auto b2 = e1; b2 < res.size(); ++b2) {
            sol = std::max(sol, res[b1] + res[b2]);
        }
    }

    return sol;
}
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    vec<pair<int, int>> visitors;

    int a, b;
    while (n--) {
        std::cin >> a >> b;
        visitors.emplace_back(a, b);
    }

    std::cout << solve(visitors, m) << ENDL;

    return 0;
}
