#include <iostream>
#include <vector>

#define ENDL '\n'

namespace {
using num = long long;

const num mod = 1e9 + 7;

template <class T>
using vec = std::vector<T>;

template <class T>
using mat = vec<vec<T>>;

mat<num> dp;

auto solve(std::vector<num>& stones, int k, int curr_idx = 1, int last_color = 0) {
    if (curr_idx + 1 == stones.size()) {
        return num(1);
    }

    if (stones[curr_idx]) {
        return solve(stones, k, curr_idx + 1, stones[curr_idx]);
    }

    auto& res = dp[curr_idx][last_color];
    if (res == -1) {
        res = 0;

        for (auto i = 1; i <= k; ++i) {
            if (i == last_color || i == stones[curr_idx + 1]) {
                continue;
            }

            res += solve(stones, k, curr_idx + 1, i);
            res %= mod;
        }
    }

    return res;
}
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, k;
    std::cin >> n >> k;

    dp = mat<num>(n + 2, vec<num>(k + 1, -1));

    std::vector<num> stones;

    stones.reserve(n + 2);
    stones.emplace_back(0);

    num foo;
    while (n--) {
        std::cin >> foo;
        stones.emplace_back(foo);
    }

    stones.emplace_back(0);

    std::cout << solve(stones, k) << ENDL;

    return 0;
}
