#include <iostream>
#include <vector>
#include <queue>
#include <tuple>

#define ENDL '\n'

namespace {
template <class T>
using vec = std::vector<T>;

template <class T>
using mat = vec<vec<T>>;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    mat<char> labyrinth(n, vec<char>(m));
    for (auto& row : labyrinth) {
        for (auto& col : row) {
            std::cin >> col;
        }
    }

    int q;
    std::cin >> q;

    int s_x, s_y, c_x, c_y;
    char c_d;
    while (q--) {
        std::cin >> s_x >> s_y >> c_x >> c_y >> c_d;

        --s_x, --s_y, --c_x, --c_y;

        auto old = labyrinth[c_x][c_y];
        labyrinth[c_x][c_y] = c_d;

        std::queue<std::tuple<int, int, int>> q;
        q.emplace(s_x, s_y, 1);

        mat<bool> visited(m, vec<bool>(n));

        auto res = 0;
        while (!q.empty()) {
            auto [curr_x, curr_y, curr_depth] = q.front();
            q.pop();

            // std::cout << curr_x << " " << curr_y << " " << curr_depth << ENDL;

            if (visited[curr_x][curr_y]) {
                continue;
            }

            visited[curr_x][curr_y] = true;

            auto new_x = curr_x, new_y = curr_y;
            auto curr_dir = labyrinth[curr_x][curr_y];

            // std::cout << "dir -> " << curr_dir << ENDL;

            switch (curr_dir) {
            case '>':
                ++new_y;
                break;
            case '<':
                --new_y;
                break;
            case '^':
                --new_x;
                break;
            case 'v':
                ++new_x;
                break;
            }

            if (new_x < 0 || new_x >= n || new_y < 0 || new_y >= m) {
                res = curr_depth;
                break;
            }

            q.emplace(new_x, new_y, curr_depth + 1);
        }

        std::cout << res << ENDL;

        labyrinth[c_x][c_y] = old;
    }

    return 0;
}
