#include<iostream>
#include<cstdio>
#include<set>
#include<vector>
using namespace std;

int n, m, q;

vector<string> maze;

vector<int> groupPointing;
vector<pair<int, int> > groupStart;
vector<pair<int, int> > groupEnd;

vector<vector<int> > moves, group;

int curGroup = 1;

void ApplyMove(int & x, int & y, char dir)
{
    if (dir == '>') y++;
    else if (dir == '<') y--;
    else if (dir == '^') x--;
    else if (dir == 'v') x++;
}

void ExploreGroup(int x, int y, int counter = 1)
{
    int origX = x, origY = y;

    group[x][y] = curGroup;
    moves[x][y] = counter;

    ApplyMove(x, y, maze[x][y]);

    if (x < 0 || x >= n || y < 0 || y >= m)
    {
        groupPointing[curGroup] = 0;
        groupEnd[curGroup] = make_pair(origX, origY);
        return;
    }

    if (group[x][y] == 0) ExploreGroup(x, y, counter+1);
    else
    {
        groupEnd[curGroup] = make_pair(origX, origY);
        if (group[x][y] != curGroup)
        {
            groupPointing[curGroup] = group[x][y];
        }
        else
        {
            groupEnd[curGroup] = make_pair(x, y);

            groupPointing[curGroup] = curGroup;

            if (groupStart[curGroup] == groupEnd[curGroup]) return;

            pair<int, int> start = groupStart[curGroup];
            groupStart[curGroup] = groupEnd[curGroup];

            x = start.first;
            y = start.second;

            counter = 1;
            pair<int, int> prev;
            while (make_pair(x, y) != groupStart[curGroup])
            {
                prev = make_pair(x, y);
                group[x][y] = curGroup+1;
                moves[x][y] = counter;
                counter++;

                ApplyMove(x, y, maze[x][y]);
            }

            groupStart.push_back(start);
            groupEnd.push_back(prev);
            curGroup++;
        }
    }
}

void FindGroups()
{
    curGroup = 1;
    for (int i=0; i<n; i++)
    {
        for (int j=0; j<m; j++)
        {
            if (group[i][j] != 0) continue;
            groupStart.emplace_back(i, j);
            groupPointing.push_back(-1);
            groupEnd.emplace_back(-1, -1);
            ExploreGroup(i, j);
            curGroup++;
        }
    }
}

int main()
{
    scanf("%d%d", &n, &m);

    moves.resize(n);
    group.resize(n);

    //filling the escape group;
    groupPointing.push_back(0);
    groupStart.emplace_back(-1, -1);
    groupEnd.emplace_back(-1, -1);

    for (int i=0; i<n; i++)
    {
        moves[i].resize(m, -1);
        group[i].resize(m, 0);

        string s;
        cin>>s;
        maze.push_back(s);
    }
    FindGroups();

    scanf("%d", &q);

    for (int qrs = 0; qrs < q; qrs++)
    {
        int startx, starty, changex, changey;
        char newC, oldC;
        scanf("%d%d%d%d", &startx, &starty, &changex, &changey);
        startx--;
        starty--;
        changex--;
        changey--;
        cin>>newC;
        oldC = maze[changex][changey];
        maze[changex][changey] = newC;

        //for (int i=0; i<n; i++) cout<<maze[i]<<endl;

        if (q > 1000 || m > 100 || n > 100)
        {
            if (group[changex][changey] != group[startx][starty]) cout<<0<<endl;
            else
            {
                if (newC == '<' && changey != 0) cout<<0<<endl;
                else if (newC == '>' && changey != m-1) cout<<0<<endl;
                else if (newC == '^' && changex != 0) cout<<0<<endl;
                else if (newC == 'v' && changex != n-1) cout<<0<<endl;
                else
                {
                    int theans = moves[changex][changey] - moves[startx][starty] + 1;
                    if (theans < 0)
                    {
                        theans += moves[groupEnd[group[changex][changey]].first][groupEnd[group[changex][changey]].second];
                    }
                    cout<<theans<<endl;
                }
            }

            maze[changex][changey] = oldC;
            continue;
        }

        set<pair<int, int> > explored;
        int ans = 0;
        while (explored.count(make_pair(startx, starty)) == 0)
        {
            //cout<<startx<<" "<<starty<<endl;
            ans++;
            explored.emplace(startx, starty);

            if (maze[startx][starty] == '>') starty++;
            else if (maze[startx][starty] == '<') starty--;
            else if (maze[startx][starty] == 'v') startx++;
            else if (maze[startx][starty] == '^') startx--;
            //else cout<<"sadge"<<endl;

            if (startx < 0 || startx >= n || starty < 0 || starty >= m)
            {
                cout<<ans<<endl;
                break;
            }
        }

        if (explored.count(make_pair(startx, starty)) > 0)
        {
            cout<<0<<endl;
        }

        maze[changex][changey] = oldC;
    }
}
