#include <bits/stdc++.h>

using namespace std;

const int N = 1500 + 3;
const int Q = 1e5 + 3;
const int LOGN = 21;

int n, m;
string s[N];
array<int, 2> adj[N][N];

int cnt_cycle, vis[N][N], w_cycle[N][N], pos_cycle[N][N], sz_cycle[N * N];
int cnt_path, w_path[N][N], pos_path[N][N];
array<int, 2> fn_node[N][N];

array<int, 2> nxt_node(int x, int y, char c){
    switch(c){
    case '<':
        y--;
        break;
    case '>':
        y++;
        break;
    case 'v':
        x++;
        break;
    case '^':
        x--;
        break;
    }

    if(x < 0 || y < 0 || x >= n || y >= m) return {n, m};
    return {x, y};
}

void init_graph(){
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j)
            adj[i][j] = nxt_node(i, j, s[i][j]);
}

void dfs(int x, int y){
    vis[x][y] = 1;
    int to_x = adj[x][y][0], to_y = adj[x][y][1];
    int vis_num = vis[to_x][to_y];
    if(vis_num == 1){
        cnt_cycle++;
        w_cycle[x][y] = cnt_cycle;
        pos_cycle[x][y] = 0;
        sz_cycle[cnt_cycle] = 1;
        vis[to_x][to_y] = 2;
    }
    else if(vis_num == 0){
        dfs(to_x, to_y);
        if(w_cycle[to_x][to_y] && (x != n || x!= m) && vis[x][y] == 2){
            w_cycle[x][y] = w_cycle[to_x][to_y];
            pos_cycle[x][y] = pos_cycle[to_x][to_y] + 1;
            sz_cycle[w_cycle[x][y]]++;
        }
    }

    vis[x][y] = 2;
}

void path_dfs(int x, int y){
    vis[x][y] = 1;
    if(w_cycle[x][y]) return;
    int to_x = adj[x][y][0], to_y = adj[x][y][1];

    if(!vis[to_x][to_y])
        path_dfs(to_x, to_y);

    if(w_cycle[to_x][to_y]){
        cnt_path++;
        w_path[x][y] = cnt_path;
        pos_path[x][y] = 0;
        fn_node[x][y] = {to_x, to_y};
    }
    else{
        w_path[x][y] = w_path[to_x][to_y];
        pos_path[x][y] = pos_path[to_x][to_y] + 1;
        fn_node[x][y] = fn_node[to_x][to_y];
    }
}

void init(){
    dfs(n, m);
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j)
            if(!vis[i][j])
                dfs(i, j);

    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j)
            vis[i][j] = false;

    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j)
            if(!vis[i][j])
                path_dfs(i, j);
}

int nd_search(int x, int y, int to_x, int to_y){
    if(w_cycle[to_x][to_y]){
        int fx, fy;
        if(w_cycle[x][y])
            fx = x, fy = y;
        else
            fx = fn_node[x][y][0], fy = fn_node[x][y][1];
        if(w_cycle[fx][fy] != w_cycle[to_x][to_y])
            return -1;

        int pos1 = pos_cycle[fx][fy];
        int pos2 = pos_cycle[to_x][to_y];
        int add;
        if(w_cycle[x][y]) add = 0;
        else add = pos_path[x][y] + 1;

        if(pos1 <= pos2) return add + pos2 - pos1;
        return add + sz_cycle[w_cycle[fx][fy]] - pos1 + pos2;
    }
    if(w_path[x][y] != w_path[to_x][to_y])
        return -1;
    if(pos_path[x][y] < pos_path[to_x][to_y])
        return -1;
    return pos_path[x][y] - pos_path[to_x][to_y];
}

int find_length(int x, int y){
    if(w_cycle[x][y]){
        if(x == n && y == m) return 0;
        return -1;
    }
    int fx = fn_node[x][y][0], fy = fn_node[x][y][1];
    if(fx != n || fy != m) return -1;
    return pos_path[x][y] + 1;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 0; i < n; ++i)
        cin >> s[i];

    adj[n][m] = {n, m};
    init_graph();
    init();

    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j){
            cout << adj[i][j][0] << "," << adj[i][j][1] << " ";
        }
        cout << "\n";
    }

    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j)
            cout << w_cycle[i][j] << " ";
        cout << "\n";
    }

    cout << "\npath\n";
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j)
            cout << w_path[i][j] << " ";
        cout << "\n";
    }

    int q;
    cin >> q;
    for(int i = 0; i < q; ++i){
        int sx, sy, cx, cy;
        char cd;
        cin >> sx >> sy >> cx >> cy >> cd;

        int t1 = nd_search(sx, sy, cx, cy);
        if(t1 == -1){
            int l = find_length(sx, sy);
            if(l == -1) cout << "0\n";
            else cout << l << "\n";
            continue;
        }

        auto nd = nxt_node(cx, cy, cd);
        int sx2 = nd[0], sy2 = nd[1];

        int t2 = nd_search(sx2, sy2, cx, cy);
        if(t1 == -1){
            int l = find_length(sx2, sy2);
            if(l == -1) cout << "0\n";
            else cout << l + t1 + 1 << "\n";
            continue;
        }

        cout << "0\n";
    }
}
