#include <bits/stdc++.h>

using namespace std;

const int N = 1500 + 3;
const int Q = 1e5 + 3;
const int LOGN = 21;

int n, m;
string s[N];
array<int, 2> adj[N][N];

int cnt_cycle, vis[N][N], w_cycle[N][N], pos_cycle[N][N], sz_cycle[N * N];
array<int, 2> fn_node[N][N];
vector<array<int, 2>> rev_adj[N][N];
int t_order, d[N][N], st[N][N], en[N][N];

array<int, 2> nxt_node(int x, int y, char c){
    switch(c){
    case '<':
        y--;
        break;
    case '>':
        y++;
        break;
    case 'v':
        x++;
        break;
    case '^':
        x--;
        break;
    }

    if(x < 0 || y < 0 || x >= n || y >= m) return {n, m};
    return {x, y};
}

void init_graph(){
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j)
            adj[i][j] = nxt_node(i, j, s[i][j]);
}

array<int, 2> dfs(int x, int y){
    array<int, 2> ans{-1, -1};

    vis[x][y] = 1;
    int to_x = adj[x][y][0], to_y = adj[x][y][1];
    int vis_num = vis[to_x][to_y];
    if(vis_num == 1){
        cnt_cycle++;
        w_cycle[x][y] = cnt_cycle;
        pos_cycle[x][y] = 0;
        sz_cycle[cnt_cycle] = 1;
        ans = {to_x, to_y};
    }
    else if(vis_num == 0){
        array<int, 2> curr = dfs(to_x, to_y);
        if(curr != array<int, 2>{-1, -1} && (x != n || y != m)){
            w_cycle[x][y] = w_cycle[to_x][to_y];
            pos_cycle[x][y] = pos_cycle[to_x][to_y] + 1;
            sz_cycle[w_cycle[x][y]]++;
            if(curr != array<int, 2>{x, y}) ans = curr;
        }
    }

    vis[x][y] = 2;
    return ans;
}

void path_dfs(int x, int y){
    vis[x][y] = 1;
    if(w_cycle[x][y]) return;
    int to_x = adj[x][y][0], to_y = adj[x][y][1];

    if(!vis[to_x][to_y])
        path_dfs(to_x, to_y);

    if(w_cycle[to_x][to_y])
        fn_node[x][y] = {to_x, to_y};
    else
        fn_node[x][y] = fn_node[to_x][to_y];
}

void init(){
    dfs(n, m);
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j)
            if(!vis[i][j])
                dfs(i, j);

    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j)
            vis[i][j] = false;

    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j)
            if(!vis[i][j])
                path_dfs(i, j);
}

void dfs_order(int x, int y){
    st[x][y] = t_order++;
    for(auto to: rev_adj[x][y]){
        int to_x = to[0], to_y = to[1];
        d[to_x][to_y] = d[x][y] + 1;
        dfs_order(to_x, to_y);
    }
    en[x][y] = t_order;
}

int parent_dist(int x, int y, int par_x, int par_y){
    if(d[x][y] < d[par_x][par_y]) return -1;
    if(st[par_x][par_y] <= st[x][y] && en[par_x][par_y] >= en[x][y]) return d[x][y] - d[par_x][par_y];
    return -1;
}

void init2(){
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j)
            if(!w_cycle[i][j])
                rev_adj[adj[i][j][0]][adj[i][j][1]].push_back({i, j});

    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j)
            if(w_cycle[i][j]){
                t_order = 0;
                dfs_order(i, j);
            }
    t_order = 0;
    dfs_order(n, m);
}

int nd_search(int x, int y, int to_x, int to_y){
    if(w_cycle[to_x][to_y]){
        int fx, fy;
        if(w_cycle[x][y])
            fx = x, fy = y;
        else
            fx = fn_node[x][y][0], fy = fn_node[x][y][1];
        if(w_cycle[fx][fy] != w_cycle[to_x][to_y])
            return -1;

        int pos1 = pos_cycle[fx][fy];
        int pos2 = pos_cycle[to_x][to_y];

        if(pos1 >= pos2) return d[x][y] + pos1 - pos2;
        return d[x][y] + sz_cycle[w_cycle[fx][fy]] - pos2 + pos1;
    }
    if(w_cycle[x][y]) return -1;
    if(fn_node[x][y] != fn_node[to_x][to_y]) return -1;
    return parent_dist(x, y, to_x, to_y);
}

int find_length(int x, int y){
    if(w_cycle[x][y]){
        if(x == n && y == m) return 0;
        return -1;
    }
    int fx = fn_node[x][y][0], fy = fn_node[x][y][1];
    if(fx != n || fy != m) return -1;
    return d[x][y];
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 0; i < n; ++i)
        cin >> s[i];

    adj[n][m] = {n, m};
    init_graph();
    init();
    init2();

    int q;
    cin >> q;
    for(int i = 0; i < q; ++i){
        int sx, sy, cx, cy;
        char cd;
        cin >> sx >> sy >> cx >> cy >> cd;
        sx--, sy--, cx--, cy--;

        int t1 = nd_search(sx, sy, cx, cy);
        if(t1 == -1){
            int l = find_length(sx, sy);
            if(l == -1) cout << "0\n";
            else cout << l << "\n";
            continue;
        }

        auto nd = nxt_node(cx, cy, cd);
        int sx2 = nd[0], sy2 = nd[1];

        int t2 = nd_search(sx2, sy2, cx, cy);
        if(t2 == -1){
            int l = find_length(sx2, sy2);
            if(l == -1) cout << "0\n";
            else cout << l + t1 + 1 << "\n";
            continue;
        }

        cout << "0\n";
    }
}
