#include <iostream>
using namespace std;
typedef long long int i;

typedef i matrix[2][2];
matrix identity = {{1,0},{0,1}};

void matrix_copy(const matrix a, matrix out) {
    for (i x=0; x<2; x++) {
        for (i y=0; y<2; y++) {
            out[x][y] = a[x][y];
        }
    }
}

void matrix_mod(matrix a, i m) {
    for (i x=0; x<2; x++) {
        for (i y=0; y<2; y++) {
            a[x][y] = a[x][y] % m;
        }
    }
}


void matrix_add(const matrix a, const matrix b, matrix out) {
    for (i x=0; x<2; x++) {
        for (i y=0; y<2; y++) {
            out[x][y] = a[x][y] + b[x][y];
        }
    }
}

void matrix_mul(const matrix a, const matrix b, matrix out) {
    for (i x=0; x<2; x++) {
        for (i y=0; y<2; y++) {
            i res = 0;
            for (i j=0; j<2; j++) {
                res += a[x][j] * b[j][y];
            }
            out[x][y] = res;
        }
    }
}

void matrix_powmod(const matrix a_in, i b, i m, matrix res) {
    matrix_copy(identity, res);
    matrix a;
    matrix temp;
    matrix_copy(a_in, a);
    matrix_mod(a, m);
    while (b) {
        if (b & 1) {
            matrix_mul(res, a, temp);
            matrix_mod(temp, m);
            matrix_copy(temp, res);
        }
        matrix_mul(a, a, temp);
        matrix_mod(temp, m);
        matrix_copy(temp, a);
        b >>= 1;
    }
}

const i m = 1000000007; // tested with 19 and 21

// 3rd example test without modulo: 1104402369930
//10 103
// 0 1 0 0 0 9 0 0 5 7

i powmod(i a, i b, i m) {
    i res = 1;
    a = a % m;
    while (b) {
        if (b & 1) {
            res = (res * a) % m;
        }
        a = (a * a) % m;
        b >>= 1;
    }
    return res;
}

i solve(i k, i first, i len, i last) {
    if (last == 0 && first == 0) {
        // len is never 0
        return (k*powmod(k-1, len-1, m)) % m;
    }
    if (last == 0 || first == 0) {
        return powmod(k-1, len, m);
    }
    // neither last and first are 0 now

/*
    i res = first != last ? 1 : 0;
    i kk = 1;
    for (i j=0; j<len; j++) {
        kk = (kk*(k-1));// % m; // CAN'T DO MOD HERE (for some reason)
        res = (kk-res) % m;
    }
*/
    matrix stuff = {{k-1, 0},{1,-1}};
    matrix magic_stuff;
    matrix_powmod(stuff, len, m, magic_stuff);
    /*
    for (i x=0; x<2; x++) {
        for (i y=0; y<2; y++) {
            cout << magic_stuff[x][y] << endl;
        }
    }
    */
    matrix in = {{k-1, 0},{first!=last,0}};
    matrix matrix_res;
    matrix_mul(magic_stuff, in, matrix_res);
    /*
    for (i x=0; x<2; x++) {
        for (i y=0; y<2; y++) {
            cout << in[x][y] << endl;
        }
    }
    for (i x=0; x<2; x++) {
        for (i y=0; y<2; y++) {
            cout << matrix_res[x][y] << endl;
        }
    }
    */
    i res = matrix_res[1][0];

    return res % m;
}

int main() {
    i n, k;
    cin >> n >> k;
    i res = 1;
    i first=0;
    i last=0;
    i uncolored=0;
    for (i j=0; j<n; j++) {
        i stone;
        cin >> stone;
        if (stone == 0) {
            uncolored++;
            continue;
        } else {
            last = stone;
            res = (res * solve(k, first, uncolored, last)) % m;
            uncolored = 0;
            first = last;
            last = 0;
            continue;
        }
    }
    res = (res * solve(k, first, uncolored, last)) % m;
    if (res < 0) res += m;
    cout << res;
    return 0;
}

