#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <utility>
using namespace std;

int n;
long long m;
pair <long long, long long> people [300005], people1 [300005];
vector <long long> moments;
int ans = 0;
int cnt [300005];

int tree [2000006];
void upd (int l, int r, int pos, int x){
    if (l == r){
        tree [pos] ++;
        return;
    }
    int mid = l + r >> 1;
    if (x <= mid) upd (l, mid, pos << 1, x);
    else upd (mid + 1, r, pos << 1 | 1, x);
    tree [pos] = tree [pos << 1] + tree [pos << 1 | 1];
}
int query (int l, int r, int pos, int ql, int qr){
    if (ql <= l && r <= qr) return tree [pos];
    if (r < ql || qr < l) return 0;
    int mid = l + r >> 1;
    return query (l, mid, pos << 1, ql, qr) + query (mid + 1, r, pos << 1 | 1, ql, qr);
}

int bruteforce (){
    int maxx = 0;
    for (int i = 1; i <= 200; i ++){
        int x = 0;
        for (int j = 1; j <= n; j ++){
            if (people [j].first <= i && i + m <= people [j].second) x ++;
        }
        for (int j = i + m; j <= 200; j ++){
            int y = 0;
            for (int k = 1; k <= n; k ++){
                if (people [k].first <= j && j + m <= people [k].second) y ++;
            }
            maxx = max (maxx, x + y);
        }
    }
    return maxx;
}

mt19937 mt (237896);

bool comp (pair <long long, long long> p1, pair <long long, long long> p2){
    return p1.second < p2.second;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

        cin >> n >> m;
        for (int i = 1; i <= n; i ++){
            cin >> people [i].first >> people [i].second;
            people1 [i] = people [i];
            moments.push_back (people [i].first);
            moments.push_back (people [i].second);
        }
        sort (moments.begin (), moments.end ());
        sort (people + 1, people + n + 1);
        sort (people1 + 1, people1 + n + 1, comp);
        int N = moments.size ();

        for (int i = 1; i <= n; i ++){
            int pos = lower_bound (moments.begin (), moments.end (), people [i].second) - moments.begin ();
            upd (0, N - 1, 1, pos);
            pos = lower_bound (moments.begin (), moments.end (), people [i].first + m) - moments.begin ();
            cnt [i] = query (0, N - 1, 1, pos, N - 1);
            cnt [i] = max (cnt [i], cnt [i - 1]);
        }
        for (int i = 1; i < 2000006; i ++) tree [i] = 0;

        for (int i = n; i >= 1; i --){
            int pos = lower_bound (moments.begin (), moments.end (), people1 [i].first) - moments.begin ();
            upd (0, N - 1, 1, pos);
            pos = upper_bound (moments.begin (), moments.end (), people1 [i].second - m) - moments.begin () - 1;
            int x = query (0, N - 1, 1, 0, pos);
            pos = lower_bound (people + 1, people + n + 1, make_pair (people1 [i].second - 2*m + 1, 0ll)) - people - 1;
            ans = max (ans, x + cnt [pos]);
        }
        cout << ans << '\n';

}
