#include <iostream>
#include <vector>
#include <algorithm>
#pragma G++ optimize ("O3")
using namespace std;

int n;
long long m;
pair <long long, long long> people [300005], people1 [300005];
vector <long long> moments;
int ans = 0;
int cnt [300005];
int N;

int fenwick [300005];
void upd (int x){
    while (x <= n){
        fenwick [x] ++;
        x += x & -x;
    }
}
int query (int x){
    int q = 0;
    while (x > 0){
        q += fenwick [x];
        x -= x & -x;
    }
    return q;
}

bool comp (pair <long long, long long> p1, pair <long long, long long> p2){
    return p1.second < p2.second || p1.second == p2.second && p1.first < p2.first;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);
    cout.tie (0);

        cin >> n >> m;
        for (int i = 1; i <= n; i ++){
            cin >> people [i].first >> people [i].second;
            people1 [i] = people [i];
            moments.push_back (people [i].first);
            moments.push_back (people [i].second);
        }
        sort (moments.begin (), moments.end ());
        sort (people + 1, people + n + 1);
        sort (people1 + 1, people1 + n + 1, comp);
        N = moments.size ();

        for (int i = 1; i <= n; i ++){
            int pos = lower_bound (people1 + 1, people1 + n + 1, make_pair (0ll, people [i].second), comp) - people1;
            upd (pos);
            pos = lower_bound (people1 + 1, people1 + n + 1, make_pair (0ll, people [i].first + m), comp) - people1;
            cnt [i] = i - query (pos - 1);
            cnt [i] = max (cnt [i], cnt [i - 1]);
        }
        for (int i = 1; i < 300005; i ++) fenwick [i] = 0;

        for (int i = n; i >= 1; i --){
            int pos = lower_bound (people + 1, people + n + 1, make_pair (people1 [i].first, 0ll)) - people;
            upd (pos);
            pos = upper_bound (people + 1, people + n + 1, make_pair (people1 [i].second - m, 0ll)) - people - 1;
            int x = query (pos);
            pos = lower_bound (people + 1, people + n + 1, make_pair (people1 [i].second - 2*m + 1, 0ll)) - people - 1;
            ans = max (ans, x + cnt [pos]);
        }
        cout << ans << '\n';

}
