#include <iostream>
#include <vector>
using namespace std;

int n, m, q;
vector <int> adj [3000006];
int par [3000006];
int in [3000006], out [3000006], d [3000006];
int t, used [3000006];
bool in_cycle [3000006];
vector <int> exits;
vector <vector <int> > cycles;
int comp [3000006];
pair <int, int> cyc_idx [3000006];

void form_cycle (int a){
    in_cycle [a] = 1;
    cyc_idx [a] = {cycles.size (), 0};
    vector <int> c = {a};
    for (int i = par [a]; i != a; i = par [i]){
        in_cycle [i] = 1;
        cyc_idx [i] = {cycles.size (), c.size ()};
        c.push_back (i);
    }
    cycles.push_back (c);
}

void find_cycles (int a){
    used [a] = t;
    if (par [a] == -1) return;
    if (used [par [a]] == t) return form_cycle (a);
    if (used [par [a]]) return;
    find_cycles (par [a]);
}

void dfs1 (int a){
    in [a] = ++t;
    for (int i : adj [a]){
        if (!in_cycle [i]){
            d [i] = d [a] + 1;
            comp [i] = comp [a];
            dfs1 (i);
        }
    }
    out [a] = ++t;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> m;
    for (int i = 0; i < n; i ++){
        string str;
        cin >> str;
        for (int j = 0; j < m; j ++){
            if (str [j] == '^'){
                if (i == 0){
                    par [i * m + j] = -1;
                    exits.push_back (i * m + j);
                }
                else{
                    par [i * m + j] = (i - 1) * m + j;
                    adj [(i - 1) * m + j].push_back (i * m + j);
                }
            }
            else if (str [j] == '<'){
                if (j == 0){
                    par [i * m + j] = -1;
                    exits.push_back (i * m + j);
                }
                else{
                    par [i * m + j] = i * m + j - 1;
                    adj [i * m + j - 1].push_back (i * m + j);
                }
            }
            else if (str [j] == 'v'){
                if (i == n - 1){
                    par [i * m + j] = -1;
                    exits.push_back (i * m + j);
                }
                else{
                    par [i * m + j] = (i + 1) * m + j;
                    adj [(i + 1) * m + j].push_back (i * m + j);
                }
            }
            else{
                if (j == m - 1){
                    par [i * m + j] = -1;
                    exits.push_back (i * m + j);
                }
                else{
                    par [i * m + j] = i * m + j + 1;
                    adj [i * m + j + 1].push_back (i * m + j);
                }
            }
        }
    }

    for (int i = 0; i < n * m; i ++){
        if (!used [i]){
            t ++;
            find_cycles (i);
        }
    }
    for (int i = 0; i < n * m; i ++) used [i] = 0;
    t = 0;
    int T = 0;
    for (int i : exits) comp [i] = i, dfs1 (i);
    for (auto c : cycles) for (int i : c) comp [i] = i, dfs1 (i);

    cin >> q;
    while (q --){
        int x, y, i, j;
        char ch;
        cin >> x >> y >> i >> j >> ch;
        x --;
        y --;
        i --;
        j --;
        int u = x * m + y, v = i * m + j;
        if (!(in [i * m + j] < in [x * m + y] && out [x * m + y] < out [i * m + j]) && !(in_cycle [comp [x * m + y]] && in_cycle [i * m + j] && cyc_idx [comp [x * m + y]].first == cyc_idx [i * m + j].first)){
            if (in_cycle [comp [u]]) cout << "0\n";
            else cout << d [u] + 1 << '\n';
            continue;
        }
        if (in [i * m + j] < in [x * m + y] && out [x * m + y] < out [i * m + j]){
            if (ch == '^'){
                if (i == 0) cout << d [u] - d [v] + 1 << '\n';
                else{
                    int w = (i - 1) * m + j;
                    if (in_cycle [comp [w]] || in [v] < in [w] && out [w] < out [v]) cout << "0\n";
                    else cout << d [u] - d [v] + 1 + d [w] + 1 << '\n';
                }
            }
            else if (ch == '<'){
                if (j == 0) cout << d [u] - d [v] + 1 << '\n';
                else{
                    int w = i * m + j - 1;
                    if (in_cycle [comp [w]] || in [v] < in [w] && out [w] < out [v]) cout << "0\n";
                    else cout << d [u] - d [v] + 1 + d [w] + 1 << '\n';
                }
            }
            else if (ch == 'v'){
                if (i == n - 1) cout << d [u] - d [v] + 1 << '\n';
                else{
                    int w = (i + 1) * m + j;
                    if (in_cycle [comp [w]] || in [v] < in [w] && out [w] < out [v]) cout << "0\n";
                    else cout << d [u] - d [v] + 1 + d [w] + 1 << '\n';
                }
            }
            else{
                if (j == m - 1) cout << d [u] - d [v] + 1 << '\n';
                else{
                    int w = i * m + j + 1;
                    if (in_cycle [comp [w]] || in [v] < in [w] && out [w] < out [v]) cout << "0\n";
                    else cout << d [u] - d [v] + 1 + d [w] + 1 << '\n';
                }
            }
            continue;
        }
        int dd = d [u] + 1 + (cycles [cyc_idx [v].first].size () + cyc_idx [v].second - cyc_idx [comp [u]].second) % cycles [cyc_idx [v].first].size ();
            if (ch == '^'){
                if (i == 0) cout << dd << '\n';
                else{
                    int w = (i - 1) * m + j;
                    if (in_cycle [comp [w]]) cout << "0\n";
                    else cout << dd + d [w] + 1 << '\n';
                }
            }
            else if (ch == '<'){
                if (j == 0) cout << dd << '\n';
                else{
                    int w = i * m + j - 1;
                    if (in_cycle [comp [w]]) cout << "0\n";
                    else cout << dd + d [w] + 1 << '\n';
                }
            }
            else if (ch == 'v'){
                if (i == n - 1) cout << dd << '\n';
                else{
                    int w = (i + 1) * m + j;
                    if (in_cycle [comp [w]]) cout << "0\n";
                    else cout << dd + d [w] + 1 << '\n';
                }
            }
            else{
                if (j == m - 1) cout << dd << '\n';
                else{
                    int w = i * m + j + 1;
                    if (in_cycle [comp [w]]) cout << "0\n";
                    else cout << dd + d [w] + 1 << '\n';
                }
            }
    }

}
