#include<bits/stdc++.h>
#define ull unsigned long long
#pragma optimize GCC Ofast

using namespace std;

/// twitch.tv/bili220022

pair<int,int> decode(char c) {
    switch(c) {
    case 'v':
        return {0, 1};
    case '^':
        return {0, -1};
    case '<':
        return {-1, 0};
    case '>':
        return {1, 0};
    default:
        cout<<"A";
        return {0,0};
    }
}

int n,m;
int q;

struct cell {
    int x;
    int y;
    pair<int,int> delta;
    bool visited = false;

    cell(int xx, int yy, char cc) {
        x = xx;
        y = yy;
        delta = decode(cc);
    }
};


bool is_outside(pair<int,int> p) {
    int &x = p.first;
    int &y = p.second;
    return (x < 0 || x >= m) || (y < 0 || y >= n);
}

vector<vector<cell>> cells;


int solve_small() {
    int sx, sy, cx, cy;
    char c;
    cin>> sy >> sx >> cy >> cx;
    cin>>c;
    sx--;
    sy--;
    cx--;
    cy--;
    pair<int, int> old_delta = cells[cy][cx].delta;
    cells[cy][cx].delta = decode(c);

    int res = 0;
    pair<int,int> current_cell = {sx, sy};
    vector<pair<int,int>> visited;
    while(true) {
        res++;
        visited.push_back(current_cell);
        cells[current_cell.second][current_cell.first].visited = true;
        //cout<<"going through "<< current_cell.first <<","<<current_cell.second<<endl;
        //cout<<"deltaX"<<cells[current_cell.second][current_cell.first].delta.first<<endl;
        //cout<<"deltaY"<<cells[current_cell.second][current_cell.first].delta.second<<endl;
        pair<int,int> next_cell = {current_cell.first  + cells[current_cell.second][current_cell.first].delta.first,
                                   current_cell.second + cells[current_cell.second][current_cell.first].delta.second};
        if(is_outside(next_cell)) {
            break;
        }
        if(cells[next_cell.second][next_cell.first].visited) {
            res = 0;
            break;
        }
        current_cell = next_cell;
    }

    cells[cy][cx].delta = old_delta;
    for(pair<int,int> C : visited) {
        cells[C.second][C.first].visited = false;
    }
    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>m;
    cells.resize(n);
    char c;
    for (int y = 0; y < n; y++) {
        for (int x = 0; x < m; x++) {
            cin>>c;
            cells[y].push_back(cell(x, y, c));
        }
    }
    cin>>q;
    while(q--) {
        cout<<solve_small()<<endl;
    }
    return 0;
}

