#include<bits/stdc++.h>
#define ull unsigned long long
#pragma optimize GCC Ofast

using namespace std;

/// twitch.tv/bili220022

pair<int,int> decode(char c) {
    switch(c) {
    case 'v':
        return {0, 1};
    case '^':
        return {0, -1};
    case '<':
        return {-1, 0};
    case '>':
        return {1, 0};
    default:
        cout<<"A";
        return {0,0};
    }
}

int n,m;
int q;

struct cell {
    int x;
    int y;
    pair<int,int> delta;
    bool visited = false;
    int cycleId = -1;
    int cyclePosition = -1;

    cell(int xx, int yy, char cc) {
        x = xx;
        y = yy;
        delta = decode(cc);
    }

    pair<int,int> getNext() {
        return {x + delta.first, y + delta.second};
    }
};


bool is_outside(pair<int,int> p) {
    int &x = p.first;
    int &y = p.second;
    return (x < 0 || x >= m) || (y < 0 || y >= n);
}

vector<vector<cell>> cells;
vector<int> cycleSize;

int solve_small() {
    int sx, sy, cx, cy;
    char c;
    cin>> sy >> sx >> cy >> cx;
    cin>>c;
    sx--;
    sy--;
    cx--;
    cy--;
    pair<int, int> old_delta = cells[cy][cx].delta;
    cells[cy][cx].delta = decode(c);

    int res = 0;
    pair<int,int> current_cell = {sx, sy};
    vector<pair<int,int>> visited;
    while(true) {
        res++;
        visited.push_back(current_cell);
        cells[current_cell.second][current_cell.first].visited = true;
        //cout<<"going through "<< current_cell.first <<","<<current_cell.second<<endl;
        //cout<<"deltaX"<<cells[current_cell.second][current_cell.first].delta.first<<endl;
        //cout<<"deltaY"<<cells[current_cell.second][current_cell.first].delta.second<<endl;
        pair<int,int> next_cell = {current_cell.first  + cells[current_cell.second][current_cell.first].delta.first,
                                   current_cell.second + cells[current_cell.second][current_cell.first].delta.second};
        if(is_outside(next_cell)) {
            break;
        }
        if(cells[next_cell.second][next_cell.first].visited) {
            res = 0;
            break;
        }
        current_cell = next_cell;
    }

    cells[cy][cx].delta = old_delta;
    for(pair<int,int> C : visited) {
        cells[C.second][C.first].visited = false;
    }
    return res;
}

void markCycles() {

    for (int y = 0; y < n; y++) {
        for (int x = 0; x < m; x++) {
               if(cells[y][x].cycleId == -1) {
                    pair<int,int> curr = {x,y};
                    int newCycleId = cycleSize.size();// 0 based
                    //cout<<"starting cycle"<<newCycleId<<endl;
                    int newPosition = 0;
                    while(cells[curr.second][curr.first].cycleId == -1) {
                        //cout<<curr.first<<","<<curr.second<<endl;
                        cells[curr.second][curr.first].cycleId = newCycleId;
                        cells[curr.second][curr.first].cyclePosition = newPosition++;
                        curr = cells[curr.second][curr.first].getNext();
                    }
                    cycleSize.push_back(newPosition);
               }
        }
    }
}

int solve_smart() {
    int sx, sy, cx, cy;
    int res = 0;
    char c;
    cin>> sy >> sx >> cy >> cx;
    cin>>c;
    sx--;
    sy--;
    cx--;
    cy--;
    pair<int, int> newDelta = decode(c);
    pair<int, int> possibleExit = {newDelta.first + cx, newDelta.second + cy};
    if(!is_outside(possibleExit)) {
        return 0;
    }
    if(cells[sy][sx].cycleId != cells[cy][cx].cycleId) { // cant meet
        return 0;
    }
    int cycleId = cells[sy][sx].cycleId ;
    int cs = cycleSize[cycleId];
    int startPos = cells[sy][sx].cyclePosition;
    int endPos = cells[cy][cx].cyclePosition;
    res = endPos >= startPos ? endPos - startPos: endPos - startPos + cs;
    res++;
    return res;
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>m;
    cells.resize(n);
    char c;
    for (int y = 0; y < n; y++) {
        for (int x = 0; x < m; x++) {
            cin>>c;
            cells[y].push_back(cell(x, y, c));
        }
    }
    cin>>q;
    if(true and n < 101 and m < 101 and q < 1001) {
        while(q--) {
            cout<<solve_small()<<endl;
        }
    }
    else { // second subtask -> cycles
        markCycles();
        while(q--) {
            cout<<solve_smart()<<endl;
        }
    }
    return 0;
}

