#include<iostream>
#include<cstdlib>
#include<ctime>
#include<vector>
#include<algorithm>
#include<random>
#include<queue>
using namespace std;
long long a=1;
long long rnd(){
    a=(a*rand()+rand())%rand();
    return a;
}
struct node{
    node *l,*r;
    int val;
    long long key;
    int siz;
    node(int val){
        this->val=val;
        this->key=rnd();
        //cout<<key<<endl;
        siz=1;
        l=nullptr;
        r=nullptr;
    }
    void recalc(){
        siz=1;
        if(l!=nullptr){
            siz+=l->siz;
        }
        if(r!=nullptr){
            siz+=r->siz;
        }
    }
};
void mmerge(node* l,node* r,node *&tree){
    if(l==nullptr){
        tree=r;
        return;
    }
    if(r==nullptr){
        tree=l;
        return;
    }
    if(l->key>r->key){
        mmerge(l->r,r,l->r);
        tree=l;
        tree->recalc();
    }else{
        mmerge(l,r->l,r->l);
        tree=r;
        tree->recalc();
    }
}
void msplit(node* tree,node*&l,node*&r,int k){
    if(tree==nullptr){
        l=r=nullptr;
        return;
    }
    if(tree->val<k){
        msplit(tree->r,tree->r,r,k);
        tree->recalc();
        l=tree;
    }else{
        msplit(tree->l,l,tree->l,k);
        tree->recalc();
        r=tree;
    }
}
node *root=nullptr;
void goOver(node* curr,int in){
    if(curr!=nullptr){
        goOver(curr->l,in+1);
        for(int i=0;i<in;i++){
            cout<<" ";
        }
        cout<<curr->val<<" "<<curr->siz<<" "<<curr->key<<endl;
        goOver(curr->r,in+1);
    }
}
void minsert(int val){
    node *newnode=new node(val);
    if(root==nullptr){
        root=newnode;
    }else{
        node *res1,*res2;
        msplit(root,res1,res2,val);
        //cout<<"1"<<endl;
        mmerge(res1,newnode,res1);
        //cout<<"2"<<endl;
        mmerge(res1,res2,root);
        //cout<<"3"<<endl;
    }
}
int cnt1(node* tree,int k){
    if(tree==nullptr){
        return 0;
    }
    int ans=0;
    if(tree->val>=k){
        if(tree->l!=nullptr){
            ans+=cnt1(tree->l,k);
        }
        ans++;
        if(tree->r!=nullptr){
            ans+=tree->r->siz;
        }
    }else{
        if(tree->r!=nullptr){
            ans+=cnt1(tree->r,k);
        }
    }
    return ans;
}
int cnt2(node* tree,int k){
    if(tree==nullptr){
        return 0;
    }
    int ans=0;
    if(tree->val<=k){
        if(tree->r!=nullptr){
            ans+=cnt2(tree->r,k);
        }
        ans++;
        if(tree->l!=nullptr){
            ans+=tree->l->siz;
        }
    }else{
        if(tree->l!=nullptr){
            ans+=cnt2(tree->l,k);
        }
    }
    return ans;
}
vector<pair<int,int> >clients;
bool cmp1(pair<int,int> a, pair<int,int> b){
    return a<b;
}
bool cmp2(pair<int,int> a, pair<int,int> b){
    if(a.second==b.second){
        return a.first>b.first;
    }
    return a.second>b.second;
}
vector<pair<int,int> >ans1,ans2;
int main(){
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    srand(time(NULL));
    int n,m;
    cin>>n>>m;
    for(int i=0;i<n;i++){
        int a,b;
        cin>>a>>b;
        clients.push_back({a,b});
    }
    sort(clients.begin(),clients.end(),cmp1);
    priority_queue<int> q1;
    for(int i=0;i<n;i++){
        //minsert(clients[i].second);
        q1.push(-clients[i].second);
        while(!q1.empty() && -q1.top()<clients[i].first+m){
            q1.pop();
        }
        //cout<<"treap"<<endl;
        //goOver(root,0);
        int cnt=q1.size();//cnt1(root,clients[i].first+m);
        ans1.push_back({clients[i].first,cnt});
    }
    root=nullptr;
    sort(clients.begin(),clients.end(),cmp2);
    for(int i=0;i<n;i++){
        minsert(clients[i].first);
        //cout<<"treap"<<endl;
        //goOver(root,0);
        int cnt=cnt2(root,clients[i].second-m);
        ans2.push_back({clients[i].second,cnt});
    }
    int max1=0,max2=0,i2=0;
    for(int i=n-1;i>=0;i--){
        while(i2<n && ans2[i2].first>=ans1[i].first+m*2){
            max2=max(max2,ans2[i2].second);
            i2++;
            //cout<<max2;
        }
        max1=max(max1,max2+ans1[i].second);
    }
    cout<<max1<<endl;
    return 0;
}
