#include<iostream>
#include<vector>
#include<utility>
using namespace std;

const int Mod=1000000007;

const int Max_N=500100;

long long n,k;
long long arr [Max_N];

long long multipl(long long a,long long b){
    return ((a*b)%Mod);
}

long long sum(long long a,long long b){
    return ((a+b)%Mod);
}

long long calc_one_side(int x){
    if(x==0){
        return 1;
    }
    long long res=k-1;
    for(int i=1;i<x;i++){
        res=multipl(res,(k-1));
    }
    return res;
}

long long calc_no_lim(int x){
    if(x==1){
        return k;
    }
    return multipl(k,calc_one_side(x-1));
}

//0 different ends , 1 equal ends
long long dp[Max_N][2];

void calc_dp(int s){
    dp[1][0]=k-2;
    dp[1][1]=k-1;
    for(int i=2;i<=s;i++){
        dp[i][0]=sum(dp[i-1][1],multipl(dp[i-1][0],k-2));
        dp[i][1]=multipl(dp[i-1][0],k-1);
    }
    return;
}

//false group zeros, true group ones
vector< pair<int,bool> > compr;

void compress(){
    int num_zeros=0;
    for(int i=0;i<n;i++){
        if(arr[i]==0){
            num_zeros++;
        }else{
            if(num_zeros>0){
                compr.push_back({num_zeros,false});
            }
            num_zeros=0;
            compr.push_back({arr[i],true});
        }
    }
    if(num_zeros>0){
        compr.push_back({num_zeros,false});
    }
    return;
}

long long calc_res(){
    calc_dp(n);
    long long res=1;
    if(compr.size()==1){
        if(compr[0].second){
            return 1;
        }else{
            return calc_no_lim(compr[0].first);
        }
    }
    if(!compr[0].second){
        res=multipl(res,calc_one_side(compr[0].first));
    }
    if(!compr[compr.size()-1].second){
        res=multipl(res,calc_one_side(compr[compr.size()-1].first));
    }
    for(int i=1;i<compr.size()-1;i++){
        if(!compr[i].second){
            if(compr[i-1].first==compr[i+1].first){
                res=multipl(res,dp[compr[i].first][1]);
            }else{
                res=multipl(res,dp[compr[i].first][0]);
            }
        }
    }
    return res;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin>>n>>k;
    for(int i=0;i<n;i++){
        cin>>arr[i];
    }
    compress();
    cout<<calc_res();
    return 0;
}
