#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

const int MAXN = 1e5 + 5;

struct Event
{
    int sortVal;
    int endTime, op;

    Event(){}
    Event(int sortVal, int endTime, int op)
    {
        this->op = op;
        this->sortVal = sortVal;
        this->endTime = endTime;
    }
};

int adVal[MAXN];

map <int, int> code;
void compress(vector <pair <int, int>> &v)
{
    set <int> s;
    for(pair <int, int> item: v)
    {
        s.insert(item.first);
        s.insert(item.second);
    }

    int ind = 0;
    for(int x: s)
    {
        code[x] = ind;
        ind++;
    }

    /*
    for(pair <int, int> &item: v)
    {
        item.first = code[item.first];
        item.second = code[item.second];
    }
    */
}

int n, m;
vector <pair <int, int>> v;

int checkTime(int startTime)
{
    int cnt = 0;
    int endTime = startTime + m;

    for(int j = 0;j<n;j++)
    {
        if(v[j].first>startTime) break;
        if(endTime<=v[j].second) cnt++;
    }

    return cnt;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;

    for(int i = 0;i<n;i++)
    {
        int a, b;
        cin >> a >> b;

        v.push_back({a, b});
    }

    compress(v);
    sort(v.begin(), v.end());

    for(int i = 0;i<v.size();i++)
    {
        adVal[i] = checkTime(v[i].first);
    }

    int answer = 0;

    for(int i = 0;i<n;i++)
    {
        answer = max(answer, checkTime(v[i].first+m) + adVal[i]);
        for(int j = i+1;j<n;j++)
        {
            if(v[j].first-v[i].first<m) continue;
            answer = max(answer, adVal[i] + adVal[j]);

            //cout << v[i].first << " " << v[j].first << " -> " << adVal[i] + adVal[j] << '\n';
        }
    }

    cout << answer << '\n';
}
