#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;

const int MAXN = 1e5 + 5;

struct Event
{
    int sortVal;
    int endttime, op;

    Event(){}
    Event(int sortVal, int endttime, int op)
    {
        this->op = op;
        this->sortVal = sortVal;
        this->endttime = endttime;
    }
};

int adVal[MAXN];

map <int, int> code;
void compress(vector <pair <int, int>> &v)
{
    set <int> s;
    for(pair <int, int> item: v)
    {
        s.insert(item.first);
        s.insert(item.second);
    }

    int ind = 0;
    for(int x: s)
    {
        code[x] = ind;
        ind++;
    }

    /*
    for(pair <int, int> &item: v)
    {
        item.first = code[item.first];
        item.second = code[item.second];
    }
    */
}

int n, m;
map <int, int> start2Cnt;
vector <pair <int, int>> v;

int checkStart(int start)
{
    int cnt = 0;
    int finish = start + m;

    for(int j = 0;j<v.size();j++)
    {
        if(v[j].first>start) break;
        if(finish<=v[j].second) cnt++;
    }

    return cnt;
}

void evalttimes()
{
    priority_queue <int, vector <int>, greater <int>> pq;
    for(int i = 0;i<v.size();i++)
    {
        //cout << v[i].first << '\n';

        while(pq.empty()==false && (i==v.size()-1 || pq.top()<v[i+1].first))
        {
            //cout << " -> " << pq.top() << '\n';

            start2Cnt[pq.top()] = checkStart(pq.top());
            pq.pop();
        }

        start2Cnt[v[i].first] = checkStart(v[i].first);
        pq.push(v[i].first+m);
    }
    while(pq.empty()==false)
    {
        start2Cnt[pq.top()] = checkStart(pq.top());
        pq.pop();
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;

    for(int i = 0;i<n;i++)
    {
        int a, b;
        cin >> a >> b;

        v.push_back({a, b});
    }

    compress(v);
    sort(v.begin(), v.end());

    evalttimes();

    int answer = 0;
    for(int i = 0;i<n;i++)
    {
        answer = max(answer, start2Cnt[v[i].first+m] + start2Cnt[v[i].first]);
        for(int j = i+1;j<n;j++)
        {
            if(v[j].first-v[i].first<m) continue;
            answer = max(answer, start2Cnt[v[i].first] + start2Cnt[v[j].first]);
        }
    }

    cout << answer << '\n';
}
