#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, k;
vector<int> a;

void read() {
    cin >> n >> k;

    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
}

int fastPow(int x, int y) {
    int answer = 1;
    while (y > 0) {
        if (y & 1) {
            answer = ((long long)answer * x) % MOD;
        }

        x = ((long long)x * x) % MOD;
        y >>= 1;
    }

    return answer;
}

void solve() {
    vector<pair<int, int>> intervals;
    for (int i = 0; i < n; ) {
        if (a[i] > 0) {
            i++;
            continue;
        }

        int to = i;
        while (to < n && a[to] == 0) {
            to++;
        }

        intervals.emplace_back(i, to - 1);
        i = to;
    }

    int ways = 1;
    for (auto &i : intervals) {
        int currWays;
        if (i.second == n - 1) {
            if (i.first == 0) {
                currWays = ((long long)(k % MOD) * fastPow(k - 1, n - 1)) % MOD;
            } else {
                int len = i.second - i.first + 1;
                currWays = fastPow(k - 1, len);
            }
        } else {
            if (i.first == 0) {
                int len = i.second + 1;
                currWays = fastPow(k - 1, len);
            } else {
                int len = i.second - i.first + 1;
                currWays = ((long long)(k % MOD) * fastPow(k - 1, len - 1)) % MOD;
                currWays = (currWays - fastPow(k - 1, len - 1) + MOD) % MOD;
                currWays = (currWays - fastPow(k - 1, len - 1) + MOD) % MOD;
                if (len == 1) {
                    currWays = (currWays + 1) % MOD;
                } else if (len == 2) {
                    currWays = (currWays + (k - 2 + MOD) % MOD) % MOD;
                } else {
                    currWays = (currWays + fastPow(k - 1, len - 2)) % MOD;
                }
            }
        }

        ways = ((long long)ways * currWays) % MOD;
    }

    cout << ways << endl;
}

int main() {
    setIO();

    read();

    solve();
}
