#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, m;
vector<string> grid;

void read() {
    cin >> n >> m;

    grid.resize(n);
    for (auto &row : grid) {
        cin >> row;
    }
}

int dirX[4] = {0, -1, 0, 1};
int dirY[4] = {-1, 0, 1, 0};

bool isOutside(int x, int y) {
    return (x < 0 || x >= n || y < 0 || y >= m);
}

int dfsTime = 0;
vector<vector<int>> visited;

bool canExit(int x, int y) {
    if (isOutside(x, y)) {
        return true;
    }

    if (visited[x][y] == dfsTime) {
        return false;
    }

    visited[x][y] = dfsTime;

    int dir;
    switch (grid[x][y]) {
        case '<' : dir = 0; break;
        case '^' : dir = 1; break;
        case '>' : dir = 2; break;
        case 'v' : dir = 3; break;
    }

    return canExit(x + dirX[dir], y + dirY[dir]);
}

int countTransitions(int x, int y) {
    if (isOutside(x, y)) {
        return 0;
    }

    int dir;
    switch (grid[x][y]) {
        case '<' : dir = 0; break;
        case '^' : dir = 1; break;
        case '>' : dir = 2; break;
        case 'v' : dir = 3; break;
    }

    return 1 + countTransitions(x + dirX[dir], y + dirY[dir]);
}

void solve() {
    int q;
    cin >> q;

    visited.resize(n, vector<int>(m, 0));

    while (q--) {
        int startRow, startCol, changeRow, changeCol;
        char newDir;
        cin >> startRow >> startCol >> changeRow >> changeCol >> newDir;

        startRow--;
        startCol--;
        changeRow--;
        changeCol--;

        char origDir = grid[changeRow][changeCol];
        grid[changeRow][changeCol] = newDir;

        dfsTime++;

        if (!canExit(startRow, startCol)) {
            cout << 0 << endl;
        } else {
            cout << countTransitions(startRow, startCol) << endl;
        }

        grid[changeRow][changeCol] = origDir;
    }
}

int main() {
    setIO();

    read();

    solve();
}
