#include<bits/stdc++.h>
using namespace std;

int n, m, q, sz;
vector<int> lab;
vector<unordered_set<int> > paths;
vector<bool> visited, cyclic;

string s;
int si, sj, ci, cj, neib, nid;
char cd;
int idx;
int steps;

int neighbour(int i, int j, char c)
{
    switch(c)
    {
        case '^':
            i--;
            break;
        case '>':
            j++;
            break;
        case 'v':
            i++;
            break;
        case '<':
            j--;
    }
    if(i >= 0 && i < n && j >= 0 && j < m) return i * m + j;
    return -1;
}

void dfs(int from)
{
    if(visited[from])
    {
        cyclic[from] = 1;
        return;
    }
    if(!paths[from].empty())
    {
        return;
    }
    visited[from] = 1;
    paths[from].insert(from);
    if(lab[from] == -1)
    {
        //cyclic[from] = 0;
        return;
    }

    dfs(lab[from]);
    paths[from].insert(paths[lab[from]].begin(), paths[lab[from]].end());
    cyclic[from] = cyclic[lab[from]];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >>n >>m;
    sz = n * m;
    lab.resize(sz);
    paths.resize(sz);
    visited.assign(sz, 0);
    cyclic.assign(sz, 0);

    int i, j, id = 0;
    for(i = 0; i < n; i++)
    {
        cin >>s;
        for(j = 0; j < m; j++, id++)
        {
            lab[id] = neighbour(i, j, s[j]);
        }
    }

    for(id = 0; id < sz; id++)
    {
        visited.assign(sz, 0);
        dfs(id);

    }

    /*
    for(id = 0; id < sz; id++)
    {
        for(int g : paths[id])
        {
            cout <<g <<" ";
        }
        cout <<"cyc: " <<cyclic[id] <<"\n";
    }
    */
    cin >>q;
    for(i = 0; i < q; i++)
    {
        cin >>si >>sj >>ci >>cj >>cd;
        si--; sj--; ci--; cj--;
        idx = si * m + sj;
        nid = ci * m + cj;
        neib = neighbour(ci, cj, cd);
        if(idx == nid)
        {
            if(neib == lab[idx]) cout <<paths[idx].size() <<"\n";
            else if(paths[neib].find(nid) == paths[neib].end()) cout <<paths[neib].size() + 1 <<"\n";
            else cout <<0 <<"\n";
        }
        else if(paths[idx].find(nid) == paths[idx].end())
        {
            if(cyclic[idx]) cout <<0 <<"\n";
            else cout <<paths[idx].size() <<"\n";
        }
        else
        {
            if(cyclic[idx]) cout <<paths[neib].size() + paths[idx].size() <<endl;
            else if(cyclic[neib]) cout <<0 <<"\n";
            else
            {
                cout <<paths[neib].size() + paths[idx].size() - paths[nid].size() <<"\n";
            }

        }
    }
}
/*
3 4
>>v>
><v>
^>>^
4
2 1 1 1 ^
2 1 2 2 >
2 1 2 1 <
1 1 2 4 ^
*/
